/*
 * DSF compiler
 *
 */
 
#define MAX_LN_LEN  300
#define MAX_REL   50

FILE* dsf;

extern cLibrarian* l;
extern cGems* gems;

char* str1 = NULL;
char* str2 = NULL;
char* str3 = NULL;
char* strrel = NULL;
int unaryrel = 0;
int RELATION_ON=0;

typedef enum {_C_NONE, _C_ADDLEXICON, _C_ADDRELATION, _C_ADDRADIX,
 _C_ADDCOMPOUND, _C_ADDCLAUSE, _C_PREADDREL, _C_ADDREL, _C_PREADDREL2,
 _C_PREADDREL3, _C_RELATION

} eCommand;

typedef enum  { _X_ZEROLEVEL, _X_RXLANGDEF, _X_CMLANGDEF, _X_CLLANGDEF,
 _X_LANGADDDEF, _X_RELADDDEF, _X_STRINGINPUT1, _X_STRINGINPUT2,
 _X_RELASSIGN, _X_FINISHLINE, _X_RELLANGDEF, _X_DRELANGDEF

} eExpected;

eCommand command;
eExpected expected;

void execute(){
  protect(str1){ protect(str2) {
  static sExpression exp,exp2,exprel;
  static sExpRelation exrel = { '\0', '\0', '\0' };
  switch (command) {
  case _C_ADDLEXICON:
    sLanguage lang;
    //gmsgs("ADD LEXICON:",str2);
    strcpy(lang.name,str2);
    strcpy(lang.kwrd,str1);
    l->addlexicon(lang);
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;
  case _C_ADDRELATION:
    sRelation rel; rel.unary = unaryrel;
    //gmsgs("ADD RELATION:",str2);
    strcpy(rel.name,str2);
    strcpy(rel.kwrd,str1);
    l->addrelation(rel);
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;
  case _C_ADDRADIX:
    strcpy(exp.str,str2);  strcpy(exp.kwrd,str1);
    l->addradix(exp);
    strcpy(exprel.str,exp.str);strcpy(exprel.kwrd,exp.kwrd);
    RELATION_ON=1;
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;
  case _C_ADDCOMPOUND:
    strcpy(exp.str,str2);  strcpy(exp.kwrd,str1);
    aGLDCell* cx;
    cx = l->addcompound(exp);
    protect(cx) {
      char* s = cx->text(TF_PLAIN);
      strcpy(exprel.str,s);strcpy(exprel.kwrd,exp.kwrd);
      delete[] s;
    }
    RELATION_ON=1;
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;
  case _C_ADDCLAUSE:
    strcpy(exp.str,str2);  strcpy(exp.kwrd,str1);
    cx = l->addclause(exp);
    protect(cx) {
      char* s = cx->text(TF_PLAIN);
      strcpy(exprel.str,s);strcpy(exprel.kwrd,exp.kwrd);
      delete[] s;
    }
    RELATION_ON=1;
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;
  case _C_RELATION:
    strcpy(exp.str,str2);  strcpy(exp.kwrd,str1);
    cx = l->searchone(exp);
    if (cx) {
      char* s = cx->text(TF_PLAIN);
      strcpy(exprel.str,s);strcpy(exprel.kwrd,exp.kwrd);
      delete[] s;
    } else {
      gmsgs("Invalid expression definition!",str2);
    }
    RELATION_ON=1;
    expected = _X_ZEROLEVEL;
    command = _C_NONE;
  break;

  case _C_PREADDREL:
    strcpy(exp2.str,str2);  strcpy(exp2.kwrd,str1);
    //gmsgs("/////////PREADDREL:",exp2.str);
    exrel.e1EXTe2[0]='\0';
    exrel.e2EXTe1[0]='\0';
  break;
  case _C_PREADDREL2:
    //gmsgs("PREADDREL2:",str2);
    strcpy(exrel.e2EXTe1,str2);
  break;
  case _C_PREADDREL3:
    //gmsgs("PREADDREL3:",str2);
    strcpy(exrel.e1EXTe2,str2);
  break;
  case _C_ADDREL:
    //gmsg("ADDREL:");
    strcpy(exrel.kwrd,strrel);
    //gmsg(exrel.kwrd);
    //gmsg(exrel.e2EXTe1);
    //gmsg(exrel.e1EXTe2);
    //gmsgs(exprel.str,exprel.kwrd);
    //gmsgs(exp2.str,exp2.kwrd);
    l->addrelation(exprel,exrel,exp2);
    *strrel='\0';
    command = _C_NONE;
  break;
  }
  }}
};

void compile(char* fn){
  if (!(dsf=fopen(fn,"r"))) { gmsgs("can't open source file",fn); return; }
  // read
  char* ln= new char[MAX_LN_LEN+1];
  //char* tln= new char[MAX_LN_LEN+1];
  char* token =new char[MAX_LN_LEN+1];
  str1 = new char[MAX_LN_LEN];
  str2 = new char[MAX_LN_LEN];
  str3 = new char[MAX_LN_LEN];
  strrel = new char[MAX_REL];
  int lno=0;
  expected = _X_ZEROLEVEL;
  while (ln = fgets(ln,MAX_LN_LEN,dsf)) {    
    lno++; char* wst;
    if (wst=strchr(ln,';')) { *wst = '\0'; } //truncate comment
    if (wst=strchr(ln,'\n')) { *wst = '\0'; } //truncate new line
    //char* buf = strdup(ln);
    //char** bp = &buf; (token = strsep(ln, " ")    
    while (strlen(ln)>0){      
      //cut line:
      //gmsg("cutting");
      char* cutter;
      if ((expected!=_X_STRINGINPUT1) && (expected!=_X_STRINGINPUT2)){
        cutter = strchr(ln, ' ');
        if (cutter) {
        char* l1; l1 = ln;
        char* t; t= token;
        while (l1!=cutter) { *t=*l1; l1++; t++; }; *t='\0';
        strcpy(ln,++cutter);
        } else strcpy(token,ln);
      }
      //gmsgs("LINE:",ln);gmsgs("TOKEN:",token);
      switch (expected){
      /* zero level - basic */
      case _X_ZEROLEVEL:
        if (!strcmp(token,"#deflang")){
	  //gmsg("DEFLANG");
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  expected = _X_LANGADDDEF;
	  command = _C_NONE;
	  break;
	}
	if (!strcmp(token,"#defrel")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  //gmsg("DEFREL");
	  expected = _X_RELADDDEF;
	  command = _C_NONE;
	  unaryrel = 0;
	  break;
	}
        if (!strcmp(token,"#defurel")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  //gmsg("DEFREL");
	  expected = _X_RELADDDEF;
	  command = _C_NONE;
	  unaryrel = 1;
	  break;
	}
	if (!strcmp(token,"radix")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  expected = _X_RXLANGDEF;
	  command = _C_NONE;
	}
	if (!strcmp(token,"compound")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  expected = _X_CMLANGDEF;
	  command = _C_NONE;
	  break;
	}
	if (!strcmp(token,"clause")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  expected = _X_CLLANGDEF;
	  command = _C_NONE;
	  break;
	}
        if (!strcmp(token,"rel")){
	  if (command !=_C_NONE) gmsgi("unfinshed definition",lno);
	  expected = _X_DRELANGDEF;
	  command = _C_NONE;
	  break;
	}
	if (!strcmp(token,"er")){
	  if ((command = _C_PREADDREL)||(command = _C_PREADDREL3)||
	     (command = _C_PREADDREL2)){
	    command=_C_ADDREL; execute();
	    expected = _X_FINISHLINE;
	    break;
	  }  else  {
  	    gmsgi("finalizing relation which wasn't defined:", lno);
	    expected = _X_FINISHLINE;
	    break;
	  }
	}
	if (!strcmp(token,"->")){
	  if ((command = _C_PREADDREL)||(command = _C_PREADDREL3)){
	     command=_C_PREADDREL2;
	     expected = _X_STRINGINPUT2;
	     break;
	  }  else {
	     gmsgi("defining extension of relation which wasn't defined:",lno);
	     expected = _X_ZEROLEVEL;
	     break;
	  }
	}
	if (!strcmp(token,"<-")){
	  if ((command = _C_PREADDREL)||(command = _C_PREADDREL2)){
	    expected = _X_STRINGINPUT2;
	    command=_C_PREADDREL3;
	    break;
	  }  else  gmsgi("defining extension of relation which wasn't defined:",lno);
	  expected = _X_ZEROLEVEL;
	  break;
	}
	// add relation
	if (l->relexist(token)){
	  if (!RELATION_ON) gmsg("can't add relation before radix/compound/clause");
	  else {
	    expected = _X_RELLANGDEF;
	    strcpy(strrel,token);
	    command = _C_NONE;
	    break;
	  }
	}
	if ((expected==_X_ZEROLEVEL) && (strlen(token)>0)) {
	   gmsgi("error at line:",lno);
	   gmsgi("unknown keyword:",token);
	   expected = _X_FINISHLINE;
	}
      break;

      /* definition of language expected after relation def */
      case _X_RELLANGDEF:
        if ((strlen(token)>0) && (l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  //gmsgs("string input1",ln);
	  command = _C_PREADDREL;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;
      /* definition of language expeced after radix/compound/clause */
      case _X_RXLANGDEF:
        if ((strlen(token)>0) && (l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_ADDRADIX;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;
      case _X_CMLANGDEF:
        if ((strlen(token)>0) && (l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_ADDCOMPOUND;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;
      case _X_CLLANGDEF:
        if ((strlen(token)>0) && (l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_ADDCLAUSE;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;
      case _X_DRELANGDEF:
        if ((strlen(token)>0) && (l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_RELATION;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;


      /* definition of language expeced after #deflang */
      case _X_LANGADDDEF:
        //gmsg("ADD LEXICON PREP.");
        if ((strlen(token)>0) && !(l->lexexist(token))){
	  strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_ADDLEXICON;
	} else {
	  gmsgs("redefinition of symbol that can't be redefined!", token);
	  expected = _X_FINISHLINE;
	  command = _C_NONE;
	}
      break;

      /* definition of relation expeced after #defrel */
      case _X_RELADDDEF:
        if ((strlen(token)>0) && !(l->relexist(token))){
          strcpy(str1,token);	  //save str. - to be included
	  expected = _X_STRINGINPUT1;
	  command = _C_ADDRELATION;
        } else {
	    gmsgs("redefinition of symbol that can't be redefined!", token);
   	    expected = _X_FINISHLINE;
	    command = _C_NONE;
	}
      break;

      /* string within "string" */
      case _X_STRINGINPUT1:
        char* tmp1;
	char* tmp2;
	//if (command==_C_PREADDREL) gmsgs("STRING0:",ln);
        if (!(tmp1 = strchr(ln,'"'))) {
	  gmsgs("error input, \"string\" expected!",ln);
	  expected= _X_FINISHLINE; break;
	}
	*str2='\0'; //clear
	tmp1++;
	//if (command==_C_PREADDREL) gmsgs("STRING1:",tmp1);
	if (!(tmp2 = strchr(tmp1,'"'))) {
	  gmsgs("error input, \"string\" expected!",ln);
	  expected= _X_FINISHLINE; break;
	}	
	
	char* tmp3; tmp3 = str2;
        while (tmp1!=tmp2) { *tmp3=*tmp1; tmp1++; tmp3++; };
	*tmp3='\0';
	//if (command==_C_PREADDREL) gmsgs("STRING3:",str2);
        tmp2++;	
	strcpy(ln,tmp2);        
	//if (command==_C_PREADDREL) gmsgs("STRING1:",str2);	
	execute(); //execute command
	expected = _X_ZEROLEVEL;
      break;
      
      /* string within %string% */
      case _X_STRINGINPUT2:
        //char* tmp1;
	//char* tmp2;
        if (!(tmp1 = strchr(ln,'`'))) {
	  gmsgs("error input, \"string\" expected!",ln);
	  expected= _X_FINISHLINE; break;
	}
	*str2='\0'; //clear
	tmp1++;
	if (!(tmp2 = strchr(tmp1,'`'))) {
	  gmsgs("error input, \"string\" expected!",ln);
	  expected= _X_FINISHLINE; break;
	}
	tmp3 = str2;
        while (tmp1!=tmp2) { *tmp3=*tmp1; tmp1++; tmp3++; };
	*tmp3='\0';
	//if (command==_C_PREADDREL2) gmsgs("STRING3:",str2);
        tmp2++;	
	strcpy(ln,tmp2);        
	//if (command==_C_PREADDREL) gmsgs("STRING2:",str2);
	execute(); //execute command     
	expected = _X_ZEROLEVEL;
      break;

      /* ->, or <- assignator expected */
      case _X_RELASSIGN:
      
      break;
      
      case _X_FINISHLINE:
        *ln='\0';
	expected = _X_ZEROLEVEL;
      break;        
      }
    }              
  }
  delete[] ln;

  delete[] token;
  delete[] str1;
  delete[] str2;
  delete[] str3;
  delete[] strrel;
  fclose(dsf);  
};
 
