// Global Error Messaging System


#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "gems.h"

/* allocate mem for buffer & initialize */
cGems::cGems(int icMBsize, int icWsize, int icCSsize){
  // allocate mem:
  mbuf = new mstr[iMBsize = icMBsize];
  watch = new void* [iWsize = icWsize];
  cseg = new cstr[iCSsize = icCSsize];
  // clear queues, buffers:
  int i;
  for (i = 0; i < iMBsize; i++) mbuf[i][0] = '\0';
  for (i = 0; i < iWsize; i++) watch[i] = NULL;
  for (i = 0; i < iCSsize; i++) cseg[i][0] = '\0';

  // all stacks are empty:
  wp = 0;
  csp = 0;

  // trace off:
  trace = 0;
};

void cGems::echo(void){ printf("\n *** Gems established! *** \n"); }

/* call break - gems screen focus */
int cGems::brk(int iln){
  printf("\n Gems BREAK...\n");
  listing();
  printf("press enter to continue...\n");
  getchar();
  return 0;
};

/* write all message buffer on screen */
int cGems::listing(void){
  printf("\n Gems Messages Listing: \n");
  for (int i = (iMBsize-1); i >= 0; i--) {
    printf(mbuf[i]);
    printf("\n");
  }
  return 0;
};

/* add new message to queue */
void cGems::msg(char* fn, int ln, char* m){
  // shift all messages in queue up:
  int i;
  for (i = (iMBsize-1); i > 0; i--) strcpy(mbuf[i], mbuf[i-1]);

  // contact message with source (code segments):
  char s[MX_MSG_LEN+1];
  char src[MX_MSG_LEN+1];
  char msg[MX_MSG_LEN+1];
  char is[34];
  s[0] = '\0';
  src[0] = '\0';
  msg[0] = '\0';
  long int l = strlen(m);

  // filename + line number
  strcat(src, ">");  l+= 1;
  strcat(src, fn);   l+= strlen(fn);
  strcat(src, ",");  l+= 1;
  sprintf(is,"%d",ln);  l+= strlen(is);
  strcat(src, is);
  strcat(src, "{");  l+= 1;

  // complete segments
  for (int j = (csp-1); j >= 0; j--) {
    strcpy(s,cseg[j]);                 /* get cseg name */
    strcat(s,"/");                     /* add / chacter e.g. SUB/X/Y... } */
    l += strlen(s);                    /* count max. lenght */
    if ((l+1)>=MX_MSG_LEN) break;
    strcat(s, msg);
    strcpy(msg, s);
  }
  // add user message
  strncat(msg, m, MX_MSG_LEN-l);
  // add srource (filename + line number):
  strcat(src, msg);
  // add new message:
  strncpy(mbuf[0], src, MX_MSG_LEN);
  if (trace) {
    // listing:
    listing();
    printf("press enter to continue...\n");
    getchar();
    //gemsint();
  }
  return;
};

/* msg with integer parameter */
void cGems::msg(char* fn, int ln, char* m, int x){
  char is[34];
  char mpar[MX_MSG_LEN+1];
  sprintf(is,"%d",x);
  strncpy(mpar,m,MX_MSG_LEN-strlen(is));
  strcat(mpar,is);
  msg(fn,ln,mpar);
};

/* msg with string parameter */
void cGems::msg(char* fn, int ln, char* m, char* x){
  char mpar[MX_MSG_LEN+1];  
  strncpy(mpar,m,MX_MSG_LEN-strlen(x)-2); 
  strcat(mpar,"`");  
  strcat(mpar,x);
  strcat(mpar,"'");  
  msg(fn,ln,mpar);
};


/* add new code segment name to "cseg" */
int cGems::sgpush(char* segName){
  if (csp < iCSsize) {
    strncpy(cseg[csp], segName, MX_CSEG_LEN);
    csp++;
    return 0;
  } else {
    msg(__FILE__,__LINE__,"Gems, sgpush: Segment stack overflowed.");
    return -1;
  }
};

/* pop cseg name stack */
int cGems::sgpop(void){
  // erase, pop name
  if (csp>0) {
    cseg[csp][0]='\0';
    csp--;
    return 0;
  } else {
    msg(__FILE__,__LINE__,"Gems, sgpop: Segment stack underflowed.");
    return -1;
  }
};

