/*

 *

 *     General Language Database - Types' definitions

 *

 *     written by: Async

 *     created: 27.5.2003

 *     filename: gldtypes.h

 */



/* CHANGES:

 *

 *

 */



// GLD CELLS

#define GLD_CT_RADIX    1

#define GLD_CT_COMPOUND 2

#define GLD_CT_CLAUSE   3

#define NULL_ID         -1

#define NULL_HK         -1

#define NULL_LANG       -1



// TEXT FORMATS

#define TF_PLAIN        0       // radix default, compond with no '|',-

#define TF_VLINE        1       // affect compound,clause only e.g. small|er

#define TF_HLINE        2       // affect compound,clause only e.g. small-er



/* GLD classes */

class cRadix;

class aGLDCell;

class cCompound;

class cClause;

class cKeyList;

class cLexicon;

class cLibrarian;



class aJay;

class cRelation;



// text search methods:

enum TSM {TSM_FROM_START,TSM_FS_EQU, TSM_BROWSE, TSM_START_KEEP};



/* typedefs */

typedef short int RELATIONID;  // relation id number

typedef short int LANGUAGEID;  // language id number

typedef short int TEXTFORMAT;  // each cell has unique string output->format

typedef long int GLDCELLID;    // cell id number (unique number, assigns

                               // DSF compiler)

typedef short int GLDCELLTYPE; // radix, compound, clause (file->memory)

typedef short int HSKEY;       // Hash key





/* reference structure (Cell_relation->cell) */

typedef struct {

  LANGUAGEID lang;

  GLDCELLID id;

  HSKEY hk;

//  GLDCELLTYPE type;

} sReference;



/* reference structure (Cell_relation->cell) */

/* note that this structure is used for binary file data storage */

typedef struct {

  LANGUAGEID lang;

  GLDCELLID id;

  GLDCELLTYPE type;

} sFileReference;



/* relation ``Card'' - used by relation bag */

typedef struct {

  char kwrd[LEX_KEYW_LEN+1];

  char name[LEX_NAME_LEN+1];

  aGLDCell* inrelation;

  aGLDCell* condition;

} sRelCard;





/* sLexLabel describes one Lexicon */

typedef struct {

  char* name;//[LEX_NAME_LEN+1];

  char* kwrd;//[LEX_KEYW_LEN+1];

  LANGUAGEID id;

} sLexLabel;



/* Expression is radix, clause or compoud in normalized form:

 * radix (bla) or (this_is_pure_radix)

 * compound (librar|ian)...no space or (open-minded) "-" delimiter

 * clause (this is pure clause)

 */

typedef struct {

  char str[MAX_EXP_LEN+1]; // radix, compound, clause

  char kwrd[LEX_KEYW_LEN+1];; // language key-word

} sExpression;



/* sLanguage */

typedef struct {

  char name[LEX_NAME_LEN+1];

  char kwrd[LEX_KEYW_LEN+1];

} sLanguage;



typedef struct {

  char name[LEX_NAME_LEN+1];

  char kwrd[LEX_KEYW_LEN+1];

  int unary;

} sRelation;



typedef struct {

  char e1EXTe2[LEX_RELEXT_LEN+1];

  char e2EXTe1[LEX_RELEXT_LEN+1];

  char kwrd[LEX_KEYW_LEN+1];

} sExpRelation;



// relation

//typedef char charRel[MAX_RELATION_LEN+1];



/* relation bag */

typedef tContainer<cRelation> cRelRefBag;



typedef tFll<aGLDCell> cCellBag;



typedef tContainer<sRelCard> cRelationBag;



typedef tContainer<cRelation> cRelContainer;

typedef tContainer<sReference> cRefContainer;

typedef tContainer<char*> cStrContainer;

typedef tFll<aGLDCell> cChainFll;

typedef tContainer<cKeyList*> cKeyListCont;

typedef tContainer<cLexicon*> cLexContainer;

typedef tContainer<sRelation> cRelList;

