unit crt3;

interface

uses strings,crt;

const

{ edline }
  editableCharsetMin = 28;
  editableCharsetMax = 254;

{ keys }

  _none_   = $FFFF;
  _null_   = $0;

  { basic }
  _Enter_  = 13;
  _Esc_    = 27;
  _Insert_ = 1082;
  _Delete_ = 1083;
  _Home_   = 1071;
  _End_    = 1079;
  _PgUp_   = 1073;
  _PgDown_ = 1081;
  _BackSpace_ = 8;
  _Tab_    = 9;
  { arrows }
  _arLeft_ = 1075;
  _arRight_= 1077;
  _arUp_   = 1072;
  _arDown_ = 1080;
  _Ctrl_arRight_ = 1116;
  _Ctrl_arLeft_  = 1115;
  _Shift_arLeft_ = 2075;
  _Shift_arRight_= 2077;
  _Shift_arUp_   = 2072;
  _Shift_arDown_ = 2080;

  { Ctrl + ? }
  _Ctrl_PgUp_    = 1132;
  _Ctrl_PgDown_  = 1118;
  _Ctrl_Home_    = 1119;
  _Ctrl_End_     = 1117;
  _Ctrl_N_       = 14;
  _Ctrl_Q_       = 17;
  _Ctrl_K_       = 11;
  _Ctrl_L_       = 12;
  _Ctrl_X_       = 24;

  { Alt + ? }
  _Alt_X_        = 1045;
  _Alt_D_        = 1032;

  { keys }
  _0_      = 48;
  _9_      = 59;

  _y_      = 121;
  _n_      = 110;
  _f_      = 102;
  _p_      = 112;
  _q_      = 113;
  _r_      = 114;
  _e_      = 101;
  _c_      = 99;
  _h_      = 104;
  _t_      = 116;
  _m_      = 109;
  _x_      = 120;

  { function keys }
  _F1_     = 1059;
  _F2_     = 1060;
  _F3_     = 1061;



  { enabled charset for wordSkip }
  wordCharset = ['A'..'Z','a'..'z',#128..#169,#181..#184,#198,#199,#208..#216,#222,'0'..'9'];

  { charset - not a word chacter }
  notWordChar = [' ',',','.','"','''','!','@','^',';','>','<','=','-','+','/','-','(',')','[',']','{','}','\','*'];
  blankChar = [' ',#9];
  NumChar = ['0'..'9','$'];
  exNumChar = ['0'..'9','a'..'f','A'..'F','x'];
  { charset - block highlight }
{  blockHLCharInit = ['{','/'];
  blockHLCharFinish = ['']}
  { highlight symbols }
  maxHLSyn = 8;


  { hexedit }
  maxEquAddr = 8; { pocet mnozin ekival. adres  }
  maxEqus = 4; { pocet adresovych ekvalentu  }

  { tabb }


type

  TFileName = string[13];
  TPath = string;
  TTitle= string[25];

  TWin = record
           x1,x2,y1,y2:byte;
         end;
  TKey = word;
  TLatr = word;

  TGBHLsta= (_hlOFF,_hlON,_hlFINISH,_ghLEAD,_ghFINISH,_ghPASS);

  TGBHL = record
           n:byte; { no. of highlight, OFF=FFh }
           sta:TGBHLsta;  { global highlight extension - status }
          end;
  PGBHL=^TGBHL;

  TStringsBase = record
               pred,next:pointer;
               texline: PChar;
             end;

  PGlobHiNote=^TGlobHiNote;
  TGlobHiNote=record
                next:PGlobHiNote;
                sln:longint;    { # of line with glob.highlight start flag }
                fln:longint;    { # of line with glob.highlight finish flag }
                                { -1 = still unfinished }
                n: byte;        { # of highlight }
              end;



  TWordBase =record                     {! TStringsBase=TWordSet!}
               next:pointer;
               param: word;
               kwrd:PChar;
             end;

  TStrings = ^TStringsBase;
  TWordSet = ^TWordBase;

  TKeyWordSet = array [#0..#255] of TWordSet;

  TMarkers = array[_0_.._9_] of word;




  TCurPos = record
              y:word;
              x:byte;
            end;

  THLSymb = string[5];

  THighlightSyn = record
              com,f:THLSymb;
              attr:word;
            end;
  THighlightGlobSyn = record
              s,f:THLSymb; { comment }
              attr:word;
            end;

{ texedit }

{  TGBHL=^;}
  TTexeditTitle= string[25];
  TTexeditDescript = record
                    win:TWin;  { window position }
                    curPos:TCurPos;  { screen cursor position }
                    lineOfs: longint;   { Y lines offset }
                    editable: boolean; { enable edit text }
                    kotva: pointer;
                    title: TTitle;
                    flName: TFileName;
                    tex:TStrings;
                    {BHL:PBHL; { block highlight color (attribute) }
                    {GBHL:TGBHL;}
                  end;

{ hexedit }
  ThexeditAddrLabel= string[10];
  ThexeditDataType = (hexeditByte,hexeditWord,hexedit12bit);
  ThexeditData = word;
  ThexeditDataAttrib = byte;
  ThexeditAttribKeys= array [0..7] of TKey;
  ThexeditAttribColors= array [0..7] of byte;
  TEquAdr=array [1..MaxEquAddr] of array [1..MaxEqus] of word;
  ThexeditDescript = record
                       win: TWin;
                       columns: byte;  { 8 / 16 .. }
                       dataType: THexeditDataType;
                       title: TTitle;
                       addrOfs: word;
                       curAddr: word;
                       leftOfs: byte;
                       LabelLen: byte; { length of AddressLabel ex.STATUS }
                       GetAddrLabel:procedure; { pointer to procedure: GetAddrLabel,
                                  to change color of label choose
                                  hexeditLabelTextColor
                                  hexeditLabelbgColor! }
                       Attrib:boolean;
                       EquAdr: TEquAdr;
                       FullView: boolean;
                     end;
{ messages }
  TMessagesDescript = record
                      win: TWin;
                      title: TTitle;
                      editable: boolean;
                      msgOfs: word;
                      destFile: TFileName;
                      destPath: TPath;
                      sourceFile: TFileName;
                      sourcePath: TPath;
                      reload,rewrite: boolean; { initialize IN/OUT procedure }
                      buffers: byte; { max. # stored messages }
                     end;
  TMessages = TStrings;

var

  sysReq: boolean; { TERMinating signal for all process }

{ edline vars. }

  KeyWordSet: TKeyWordSet;
  defaultWCdraw: byte;
  HLSyn: array [0..maxHLSyn] of THighlightSyn;     { line - local highlight }
  HLGSyn: array [0..maxHLSyn] of THighlightGlobSyn;{ global highlight }
  HLNum: byte;
  GsynhiCounter,LsynhiCounter: byte;

  edlineTabbLength :byte;

  edlineTextColor,edlineBgColor,

  edlineMarkedTextColor,edlineMarkedBgColor: byte;
  edlineExit: boolean;
  edlineInsert: boolean;
  edlineCurPtr: byte;        { character pointer }
  edlineEditOver: boolean;   { edit text longer than defined in L var. }
  edlineBlankDELETEleave: boolean; { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACEleave: boolean; { leave if CurPtr=0 + Backspace pressed }

  edlineMarkLineOverLeave: boolean; { if cur>len(str) or cur<len then leave... }

  edlineEveryModify: boolean;
  edlineEditable: boolean;
  edlineMarkX1,edlineMarkX2: byte; { marked text .. }
  edlineMarkColumn,                { mark coulumn }
  edlineLeaveLRkey:boolean;
  edlineLastKey:Tkey;
  edlineHighlight:boolean;
  edlineWWrapFracStr:string;
  edlineWordWrap:boolean;
  edlineWWrapEvent:boolean;


{ texedit }

  texeditNumberLines: boolean;
  texeditLeftDist: byte;
  texeditBgColor,texeditTextColor,
  texeditLinesNumbersTextColor,
  texeditLinesNumbersBgColor,
  texeditLineTextColor,
  texeditLineBgColor,
  texeditTermLineBgColor,
  texeditMarkerTextColor,
  texeditMarkerBgColor,
  texeditTitleTextColor,
  texeditTitleBgColor: byte;
  texeditMarkers: TMarkers;
  texeditClipboard: TStrings;
  texeditExit: boolean;
  texeditLineHighlight,
  texeditEditOver:boolean;

{ hexedit }
  hexeditBgColor,hexeditTextColor: byte;
  hexeditEditBgColor,hexeditEdittextColor: byte;
  hexeditAddressTextColor,
  hexeditAddressBgColor,
  hexeditTitleTextColor,
  hexeditTitleBgColor : byte;
  hexeditExit: boolean;
  hexeditEditable:boolean;
  hexeditAddrLabel: ThexeditAddrLabel;
  hexeditLabelAddr: word; { address to get label.. }
  hexeditLabelTextColor,hexeditLabelBgColor: byte;
  hexeditAttribKeys: ThexeditAttribKeys;
  hexeditAttribTextColor,hexeditAttribBgColor: ThexeditAttribColors;

{ message box }

  msgCurMessages: TMessages;           { pointer to current message buffer }
  msgCurDescript: ^TMessagesDescript; { pointer to current message buffer's
                                        descriptor }
  msgTextColor,
  msgBgColor: byte;


{ get key }
  switchKeys: word;
  key: TKey;  { storage of last keyboard pressed key }
  BIOSswitchKeysStat: word absolute $0000:$0417;



function hexToInt(h:string;var errPosition:byte):longInt;
function IntToHex(x:word;nums:byte):string;
function IntToBin(w:word;nums:byte):string;
procedure MB_ERRINF(m:string);

procedure edline(x,y,l:byte;var line:string;BHLptr:pointer);

{ colorized keywords write }
procedure addKeyWord(kwrd: string; param: word);
procedure destroyKeyWordset;
procedure WCwrite(var s:string;HL:PGBHL);

{ TStrings }
procedure loadStringsFile(fn:string;var t:TStrings);
procedure addLine(var tex:TStrings;Stexline:string);
procedure deleteLine(var tex:TStrings);
procedure insertLine(var tex:TStrings;Stexline:string);
procedure modifyLine(var tex:TStrings;texline:string);
procedure goNextLine(var tex:TStrings);
procedure goPredLine(var tex:TStrings);
function getCurLine(var tex:TStrings): string;
procedure goForLines(var tex:TStrings;n:word);
procedure goBackLines(var tex:TStrings;n:word);
function getNLines(var tex:TStrings):word;
procedure destroyStrings(var tex:TStrings);

{ markers - part of TEXEDIT! }
function lineMarked(l:word;var m:TKey):boolean;
procedure eraseMarkers(var m:TMarkers);




{ TEXedit }
procedure texedit(var ds:TTexeditDescript;var tex:TStrings);
procedure loadTexFile(var ds:TTexeditDescript);
procedure loadTexSynhi(var ds:TTexeditDescript);
procedure addLsynhi(l,f:string;atr:byte);
procedure addGsynhi(l,f:string;atr:byte);

{ HEXedit }
procedure hexedit(var ds:THexeditDescript;var d: array of THexeditData;
                  var attrib: array of THexeditDataAttrib);
(*
{ messages }
procedure Msg(m: string);
procedure viewMsg(var m: TMessages; var ds: TMessagesDescript);
procedure switchMsgBox(var m: TMessages; var ds: TMessagesDescript);
*)

{ misc. of CRT3 }
function getKey:TKey;
function getKeyInt:TKey;
function inKey:TKey;


implementation

uses inifile,dos;

var i,j:word;

{
--- convert integer to hex string -------------------------------------
}

function IntToHex(x:word;nums:byte):string;
var
  i:byte;
  result:string;
begin
  result:= '';
  for i:=0 to nums-1 do begin
    if (x and $000F) <10 then
      result:= char((x and $000F)+48) + result
    else
      result:= char((x and $000F)+55) + result;
    x:= x shr 4; {ext #}
  end;
  IntToHex:= result;
end;


{
--- convert integer to bin string -------------------------------------
}

function IntToBin(w:word;nums:byte):string;
var
  i:byte;
  x:word;
  result:string;
begin
  result:='';
  x:=w;
  for i:=1 to nums do begin
    if (x mod 2)=1 then result:= '1'+result
     else result:= '0'+result;
    x:= x div 2;
  end;
  intToBin:= result;
end;

{
--- convert HEX to integer --------------------------------------------
}

function hexToInt(h:string;var errPosition:byte):longInt;
var
  i:byte;
  exp: longInt;
  result: longInt;
begin
  result:= 0;
  errPosition:=0;
  exp:= 1;
  for i:= length(h) downto 1 do begin
    case h[i] of
      '0'..'9': result:= result + (exp * (byte(h[i])-48));
      'A'..'F': result:= result + (exp * (byte(h[i])-55));
      'a'..'f': result:= result + (exp * (byte(h[i])-87));
      else errPosition:= i;
    end;
    exp:= exp * $10;
  end;
  hexToInt:= result;
end;


{
--- shift pressed ? --------------------------------------------------
}

function sw_Shift: boolean;
begin
  sw_Shift:= not ((switchKeys and $0003)=0)
end;

{
--- returns pressed key -----------------------------------------------
}

function getKey:TKey;
var
  key: TKey;
begin
  key:= byte(readkey);
  if key=0 then begin
    key:= byte(readkey);
    key:= key + 1000; { shift Ctrl + ... }
    {if sw_Shift then key:= key + 2000;}
  end;
  switchKeys:= BIOSswitchKeysStat;
  getKey:= key;
end;


{
--- returns pressed key ----------------------------------------------

: testing keypressed, if not leave this routine.
}

function inKey:TKey;
begin
  inKey:=_none_;
  if keypressed then inKey:= getKey;
end;


{
--- returns pressend key, interrupt by setting sysReq -----------------
}

function getKeyInt:TKey;
var
  key:TKey;
begin
  repeat
    key:= _none_;
    key:= inKey;
  until (key<>_none_) or sysReq;
  getkeyInt:= key;
end;

{
--- tabb replace ------------------------------------------------------
}
procedure tabbRepl(var s:string);
var
  x,spaces,i:byte;
  rs: string[10];
begin
  rs:='';
  {for x:=1 to edlineTabbLength do rs:= rs + ' ';}
  x:=pos(char(_Tab_),s);
  while x<>0 do begin
    s[x]:= ' ';
    spaces:= edlineTabbLength-(x mod edlineTabbLength);
    rs:='';
    for i:=1 to spaces do rs:= rs + ' ';
    insert(rs,s,x);
    x:= pos(char(_Tab_),s);
  end;
end;


{
--- change cursor -----------------------------------------------------
}
procedure changeCursor;
begin
  case edlineInsert of
    true: asm          { small }
            mov ah,$01
            mov ch,$11
            mov cl,$12
            int $10
          end;
    false:asm          { large }
            mov ah,$01
            mov ch,$02
            mov cl,$12
            int $10
          end;
  end;
end;

procedure curOn;
begin
  changeCursor;
end;

procedure curOff;
begin
 asm          { off }
   mov ah,$01
   mov ch,$01
   mov cl,$00
   int $10
 end;
end;



{
 edline misc - word skip: e.g.:

  before:               _ello world!
  after Ctrl+arrow      hello _orld!

}

{
--- goto next word ----------------------------------------------------
}
function gotoNextWord(var s:string; cur:byte): byte;
var
  i,l: byte;
  enWord: boolean;
begin
  i:= cur;
  l:= length(s);
  enWord:= false;
  repeat
    inc(i);
    if not (s[i] in wordCharset) then enWord:= true;
  until ((s[i] in wordCharset) and enWord) or (i>=l);
  if i>=l then i:= l+1;
  gotoNextWord:= i-1;
end;

{
--- goto pred word ----------------------------------------------------
}
function gotoPredWord(var s:string; cur:byte): integer;
var
  i,l: byte;
  enWord: boolean;
begin
  i:= cur;
  l:= length(s);
  enWord:= false;
  if i>1 then
    repeat
      dec(i);
      if (s[i] in wordCharset) then enWord:= true;
    until ((not(s[i] in wordCharset)) and enWord) or (i<=1);
  if i>=l then i:= 1;
  gotoPredWord:= i;
end;


{
--- edit line ---------------------------------------------------------

ukoncuje se pomoci klaves Enter, sipky nahoru, Dolu (zmeni text), Esc
ukoci rutinu, ale nezmeni line.

}

procedure edline(x,y,l:byte;var line:string;BHLptr:pointer);
label
 edlineRedraw, edlineEnd;
var
  eline: string;
  Oline: string[80];
  exitf,dontErase: boolean;
  lineLength:byte;
  intExit: boolean;
  i: word;
  leftOfs:byte;
  deltaOfs: byte;
  rs: string[10];

procedure clearEditSpace;
var
  i:word;
begin
  if (length(eline)-leftOfs)<l then begin
    Oline:= '';
    gotoxy(x+length(eline)-leftOfs,y);
    for i:=(x+length(eline)-leftOfs) to x+l do Oline:= Oline + ' ';
    write(Oline);
  end;
end;

begin
  exitf:= false;
  eline:= line;
  leftOfs:= 0;
  { print string }
  textColor(edlineTextColor);
  textBackground(edlineBgColor);

  changeCursor;
  dontErase:= false;
  intExit:= false;
  { edit line }
  repeat
    edlineRedraw:
    if not dontErase then begin
      clearEditSpace;                    { clear blank space }
    end;

    gotoxy(x,y);                         { refresh text }
    Oline:= '';                          { truncate to length - chars.! }
    lineLength:= length(eline);
    if lineLength>0 then begin
      if (lineLength-leftOfs)>l then begin { edit over the LineLength(l) }
        for i:= leftOfs to (l+leftOfs-1) do  { print part of line }
          Oline:= Oline + eline[i+1];
        Oline:= Oline;
      end
      else
        for i:= leftOfs to lineLength-1 do   { print whole end of/line }
        Oline:= Oline + eline[i+1];
    end;

    if (lineLength-leftOfs)<l then begin
      Oline:= Oline+ ' ';
      if edlineHighlight then
        WCwrite(Oline,BHLptr) else write(Oline);         { print }

    end else
      if edlineHighlight then
        WCwrite(Oline,BHLptr) else write(Oline);

    gotoxy(x+edlineCurPtr,y);            { refresh cursor position }
    dontErase:= false;
    { get operator's command }
    if intExit then goto edlineEnd;
    if (not edlineExit) then begin
     key:= getKeyInt;

    case key of

      _Insert_: begin                    { change Insert/Overwrite }
        edlineInsert:= not edlineInsert;
        changeCursor;
        dontErase:= true;
      end;

      _Delete_: begin                    { delete character }
        if edlineEditable then begin
         if edlineBlankDELETEleave
           and ((edlineCurPtr+leftOfs)>=length(eline)) then begin
          exitf:= true;
          line:= eline;
         end
         else
          delete(eline, leftOfs+edlineCurPtr+1, 1)
        end;
      end;

      _Home_:   begin                    { cursor at the begin of string }
        edlineCurPtr:= 0;
        leftOfs:=0;
        dontErase:= true;
      end;

      _End_:    begin                    { cursor at the end od str. }
        leftOfs:= 0;
        lineLength:= length(eline);
        if lineLength > l then
          leftOfs:= lineLength - l;      { left line shift }

        edlineCurPtr:= length(eline)-leftOfs;
        dontErase:= true;
      end;

      _BackSpace_: begin                 { backspace delete }
        if edlineEditable then begin
         if edlineCurPtr>0 then begin
          delete(eline,leftOfs+edlineCurPtr,1);
          dec(edlineCurPtr);
         end
         else
          if leftOfs>0 then begin
            dec(leftOfs);
            delete(eline,leftOfs,1);
          end
          else
            exitf:= edlineCurHomeBACKSPACEleave; { leave edline }
        end;
      end;

      _arLeft_: begin                            { cur. left move }
        if edlineCurPtr>0 then
          dec(edlineCurPtr)
        else begin
          if edlineLeaveLRkey then intExit:=true;
          if leftOfs>0 then begin
            dec(leftOfs);
          end;
        end;
        dontErase:= true;
      end;

      _arRight_:begin                           { cur. right move }
        if (edlineCurPtr<(l-1)) then
          inc(edlineCurPtr)
        else  begin
          if edlineLeaveLRkey then intExit:=true;
          if (leftOfs<(255-l)) and edlineEditOver then
            inc(leftOfs);
        end;
        dontErase:= true;
      end;

      _Ctrl_arRight_:begin                      { jump to next word }
        lineLength:= length(eline);
        edlineCurPtr:= gotoNextWord(eline, edlineCurPtr+leftOfs+1);
        if edlineCurPtr>=(l-1) then begin
          leftOfs:= (edlineCurPtr - l)+1;
          edlineCurPtr:= l-1;
        end;
      end;

      _Ctrl_arLeft_: begin                     { jump to preceeding word }
        lineLength:= length(eline);
        deltaOfs:= gotoPredWord(eline, edlineCurPtr+leftOfs+1);
        if edlineCurPtr<1 then begin
          leftOfs:= deltaOfs;
        end
        else
          if deltaOfs>= leftOfs then
            edlineCurPtr:= deltaOfs - leftOfs
          else begin
            edlineCurPtr:= 0;
            leftOfs:= deltaOfs;
          end;
      end;

      _Shift_arRight_: begin                   { mark text - unimplemented yet }

      end;

      _Shift_arLeft_: begin                    { mark text - unimplemented yet }

      end;

      _tab_:begin                              { soft tabb. }

              for i:=1 to edlineTabbLength do begin
               lineLength:=length(eline);

               if ((edlineCurPtr+1)>=l) and edlineEditOver then
                 inc(leftOfs)
               else
                 if edlineCurPtr<l then inc(edlineCurPtr);



               if (lineLength-leftOfs)< l then begin
                 if (edlineCurPtr+leftOfs)>lineLength then begin
                  { fill ' ' to cursor }
                  for i:=(lineLength+1) to (leftOfs+edlineCurPtr-1) do
                    eline:= eline + ' ';
                 end;
                insert(' ',eline,edlineCurPtr+leftOfs);
                dontErase:= true;

              end;
             end;
            end;

      { editable characters - character input }

      editableCharsetMin..editableCharsetMax: begin
        if ((edlineCurPtr+leftOfs)<255) and edlineEditable then begin

         case edlineInsert of

          true: begin                          { insert character }
            lineLength:=length(eline);
            if ((edlineCurPtr+1)>=l) and edlineEditOver then
              inc(leftOfs)
            else
              if edlineCurPtr<l then inc(edlineCurPtr);

            if (lineLength-leftOfs)< l then begin
              if (edlineCurPtr+leftOfs)>lineLength then begin
                  { fill ' ' to cursor }
                for i:=(lineLength+1) to (leftOfs+edlineCurPtr-1) do
                  eline:= eline + ' ';
              end;
              insert(char(key),eline,edlineCurPtr+leftOfs);
              dontErase:= true;
            end;
          end;
                                               { overwrite character }
          false: begin
            lineLength:=length(eline);
            if (edlineCurPtr+leftOfs)< lineLength then begin
              eline[leftOfs+edlineCurPtr+1]:= char(key);
              inc(edlineCurPtr);
              dontErase:= true;
              { pro hexedit - vypadne a posune doprava }
              if edlineLeaveLRkey and (edlineCurPtr>(l-1)) then begin
                intExit:=true;
                key:= _arRight_;
                goto edlineRedraw;
              end;
            end
            else begin
              if (edlineCurPtr+leftOfs)>lineLength then begin
                  { fill ' ' to cursor }
                for i:=(lineLength+1) to (leftOfs+edlineCurPtr) do
                  eline:= eline + ' ';
              end;
              if lineLength< 255 then begin
                if edlineCurPtr<l then begin
                  inc(edlineCurPtr);
                  eline:= eline + char(key);
                end
                else begin
                  if edlineEditOver then begin
                    eline:= eline + char(key);
                    inc(leftOfs);
                  end;
                end;
                dontErase:= true;
              end;
            end;
          end;

         end;
             { word wrap }
         if (length(eline)>l) and (edlineWordwrap) then begin
           edlineWWrapEvent:=true;
           { string fragment to new line }
           i:=length(eline);
         if i>1 then begin
           repeat
            dec(i);
          until (eline[i] in notWordChar) or (i<2);
         end;
           edlineWWrapFracStr:=copy(eline,i+1,length(eline)-i+1);
           delete(eline,i,length(eline)-i+1);
           exitf:=true;
         end;

        end;
      end;
      else
        exitf:= true; { for commands... }
     end;
    end;
    edlineEnd:
  until (key = _Enter_) or (key=_Esc_) or edlineExit or
        (key = _arUp_) or (key =_arDown_) or exitf or sysReq or intExit;

  if (key = _Enter_) or (key = _arUp_) or (key =_arDown_) or
     edlineEveryModify or intExit then line:=eline; { valid editing }

  if edlineLeaveLRkey then
     edlineLastKey:=key;
  if not exitf then key:= 0;
end;


{
--- scrollScreenDown --------------------------------------------------
}
procedure scrollScreenDown;
begin
  gotoxy(1,1);
  insLine;
end;

{
--- scrollScreenUp ----------------------------------------------------
}
procedure scrollScreenUp;
begin
  gotoxy(1,hi(windMax)-hi(windMin)+1);
  writeln;
end;

{
--- add line to the end of TStrings data type -------------------------

* vyzaduje promenou tex jako KOTVU!

* pointer NEOVLIVNUJE!!! tudiz po 1. volani a nastaveni pointeru se JIZ
  nemusime starat o nastavovani pointeru na KOTVU!!!

* v tex vraci aktuali pointer na pridanou lajnu

-je stejna jako insertLine.;

}
procedure addLine(var tex:TStrings;Stexline:string);
var
  newLine,last: TStrings;
  saveKotvu: pointer;
  texline: PChar;
begin

  new(newLine);
  getMem(newLine^.texline,length(Stexline)+1); { allocate mem. }
  strPCopy(newLine^.texline,Stexline);         { copy }

  if tex=nil then begin
    tex:= newLine;
    tex^.next:= tex;
    tex^.pred:= tex;
  end
  else begin
    if (tex=tex^.pred) and (tex=tex^.next) then begin
      newLine^.pred:= tex;       { build-in to database }
      newLine^.next:= tex;
      tex^.pred:= newLine;
      tex^.next:= newLine;
    end
    else begin
      newLine^.pred:= tex^.pred;       { build-in to database }
      newLine^.next:= tex;

      last:= tex^.pred;
      last^.next:= newLine;

      tex^.pred:= newLine;
    end;
  end;
end;

{
--- destroy strings ---------------------------------------------------
}
procedure destroyStrings(var tex:TStrings);
var
  pseudokotva,next: pointer;
begin
  if tex<>nil then begin
    pseudokotva:= tex;
    repeat
      next:= tex^.next;
      strDispose(tex^.texline);
      dispose(tex);
      tex:= next;
    until next=pseudokotva;
    tex:= nil;
  end;
end;

{
--- delete line from strings ------------------------------------------

 zmaze aktualni texline

 vraci ukazatel na nasledujici lajnu (tu co nasledovala za zmazanou)
}

procedure deleteLine(var tex:TStrings);
var
  predP, nextP: TStrings;
begin
  predP:= tex^.pred;       { prepare to contact database }
  nextP:= tex^.next;

  predP^.next:= nextP;     { CONTACT }
  nextP^.pred:= predP;

  strDispose(tex^.texline);{ free text memory }
  dispose(tex);            { free line mem. }
  tex:= nextP;
end;

{
--- insert line to current position -----------------------------------
}

procedure insertLine(var tex:TStrings;Stexline:string);
var
  newLine,predP: TStrings;
begin
  new(newLine);
  getMem(newLine^.texline,length(Stexline)+1);
  strPCopy(newLine^.texline,Stexline);

  newLine^.pred:= tex^.pred;                   { build-in to database }
  newLine^.next:= tex;
  predP:= tex^.pred;
  predP^.next:= newLine;

  tex^.pred:= newLine;
  tex:= newLine;
end;

{
--- modify line -------------------------------------------------------
}

procedure modifyLine(var tex:TStrings;texline:string);
begin
  strDispose(tex^.texline);
  getMem(tex^.texline,length(texline)+1);
  strPCopy(tex^.texline,texline);
end;

{
--- sets the current pointer to next line -----------------------------
}

procedure goNextLine(var tex:TStrings);
begin
  tex:= tex^.next;
end;

{
--- sets the current pointer to 'pred' line ---------------------------
}

procedure goPredLine(var tex:TStrings);
begin
  tex:= tex^.pred;
end;

{
--- get current line --------------------------------------------------
}

function getCurLine(var tex:TStrings): string;
begin
  getCurLine:= strPas(tex^.texline);
end;

{
--- go forward N line -------------------------------------------------

vyzaduje tex jako KOTVU jinak se to chova jako offsetLine;
}

procedure goForLines(var tex:TStrings;n:word);
var
  i: word;
begin
  for i:=1 to n do
    tex:= tex^.next;
end;

{
--- go backward N line ------------------------------------------------

vyzaduje tex jako KOTVU jinak se to chova jako offsetLine;
}

procedure goBackLines(var tex:TStrings;n:word);
var
  i:word;
begin
  for i:=1 to n do
    tex:= tex^.pred;
end;

{
--- get Number of Lines -----------------------------------------------

vraci pocet lajn
}
function getNLines(var tex:TStrings):word;
var
  n: word;
  pseudokotva: pointer;
begin
  n:=0;
  pseudokotva:= tex;
  if tex<>nil then begin
    if tex^.next=tex then n:= 1
    else begin
      n:=1;
      repeat
        inc(n);
        tex:= tex^.next;
      until tex^.next=pseudokotva;
    end;
  end;
  getNLines:= n;
  tex:= pseudokotva;
end;

{
--- search word in strings ----------------------------------------------
}
procedure stringsWordSearch(var tex:TStrings;kotva:TStrings;s:string;var ct:longint);
var
  line:string;
begin
  if s<>'' then begin
    repeat
      goNextLine(tex);
      line:=getCurLine(tex);
      inc(ct);
    until (pos(s,line)<>0) or (tex^.next=kotva);
 end;
end;
{
--- load text file ------------------------------------------------------
- function automatically allocate required memory.
}

procedure loadStringsFile(fn:string;var t:TStrings);
var
  f:text;
  s:string;
begin
  {$I-}
  {t:= nil;}
  assign(f,fn);
  reset(f);
  if IOResult<>0 then begin
    MB_ERRINF('Path/File not exist.');
    exit;
  end;
  while not eof(f) do begin
    readln(f,s);
    tabbRepl(s);   { replace tab with space }
    addLine(t,s);
  end;
  close(f);

  {$I+}
end;

{
--- save text file ------------------------------------------------------
- function needs t as @ first line.
}

procedure saveTexFile(fn:string;var t:TStrings);
var
  f:text;
  k:TStrings;
  s:string;
  choice:TKey;
begin
  {$I-}
  assign(f,fn);
  reset(f);
  choice:=_y_;
  if IOResult=0 then begin
    MB_ERRINF('File already exist, rewrite [Y,y, any key=no]');
    choice:= getKey;
    close(f);
  end;
  { save? }
  if (choice=_Y_) or (choice=_y_) then begin
      rewrite(f);
      if IOResult<>0 then begin
        MB_ERRINF('File can''t be created.');
        close(f);
        exit;
      end;
      k:= t;
      if k<>nil then
        repeat
          s:=getCurLine(k);
          goNextLine(k);
          writeln(f,s);
          if IOResult<>0 then begin
            MB_ERRINF('I/O error during write');
            break;
          end;
        until t=k;
      close(f);
  end;

  {$I+}
end;


{
--- line marked ? -----------------------------------------------------

marker at this line ?
}
function lineMarked(l:word;var m:TKey):boolean;
var
  i: byte;
begin
  lineMarked:= false;
  for i:=_0_ to _9_ do
    if texeditMarkers[i]=l then break;
  if texeditMarkers[i]=l then begin
    lineMarked:= true;
    m:= i;
  end;
end;

{
--- erase markers -----------------------------------------------------
}
procedure eraseMarkers(var m:TMarkers);
var
  i: TKey;
begin
  for i:=_0_ to _9_ do
    m[i]:= $FFFF;
end;

{

  Keyword highlight routines

}

{
--- add word to set ---------------------------------------------------
}

procedure addWord(var ws: TWordSet; kwrd:string; param: word);
var
  pws:TWordSet;
begin

  if kwrd<>'' then begin
    if ws=nil then begin
      new(ws);
      ws^.next:= ws;        { point to itself }
    end
    else begin
      pws:= ws;             { save }
      new(ws);              { cerate new }
      ws^.next:= pws^.next; { exchange next }
      pws^.next:= ws;       { contact neighbour }
    end;
    ws^.param:= param;
    getMem(ws^.kwrd,length(kwrd)+1); { allocate mem. }
    strPCopy(ws^.kwrd,kwrd);         { copy }
  end;
end;

procedure addKeyWord(kwrd: string; param: word);
begin
  addWord(KeyWordSet[kwrd[1]],kwrd,param);
end;

{
--- destroy word set -------------------------------------------------
}

procedure destroyWordset(var ws: TWordSet);
var
  zmiz:TWordSet;
begin
  if ws<>nil then
   repeat
    zmiz:= ws^.next;       { get next^2 cell }
    ws^.next:= zmiz^.next; { contact 2nd neighbour or self }
    strDispose(zmiz^.kwrd);
    dispose(zmiz);         { kill your neighbour or selfkill }
   until ws=zmiz;
end;

{
--- destroy key-word set ----------------------------------------------
}

procedure destroyKeyWordset;
var
  i: byte;
begin
 for i:=0 to 255 do
   destroyWordSet(KeyWordSet[char(i)]);
end;


{
--- get word param ---------------------------------------------------
}

function getParamWS(var ws:TWordSet; s:string):word;
var
  ps: PChar;
  finp: pointer;
begin
  getParamWS:= $FFFF;     { preset: not found }
  if not (ws=nil) then begin
    getMem(ps,length(s)+1); { allocate mem. }
    strPCopy(ps,s);         { copy }
    finp:=ws;

    repeat
     if strComp(ps,ws^.kwrd)=0 then getParamWS:= ws^.param;
      ws:= ws^.next;

    until ws=finp;
    strDispose(ps);         { dispose PChar }
  end;
end;


{
--- add global highlight note ----------------------------------------

unused.
}

procedure addGlobHiNote(var hln:PGlobHiNote;l:longint;n:byte);
var
  tmp:PGlobHiNote;
begin
  new(tmp);    { create new }
  tmp^.next:= hln;
  tmp^.n:=n;
  tmp^.sln:=l;
  tmp^.fln:=-1; { default - not finished }
  hln:= tmp;
end;


{
--- add local synhi ---------------------------------------------------
}
procedure addLsynhi(l,f:string;atr:byte);
begin
  if LsynhiCounter<=maxHLSyn then begin
    HLSyn[LsynhiCounter].com:=l;
    HLSyn[LsynhiCounter].f:=f;
    HLSyn[LsynhiCounter].attr:=atr;
  end;
  inc(LsynhiCounter);
end;

{
--- add global synhi --------------------------------------------------
}
procedure addGsynhi(l,f:string;atr:byte);
begin
  if GsynhiCounter<=maxHLSyn then begin
    HLGSyn[GsynhiCounter].s:=l;
    HLGSyn[GsynhiCounter].f:=f;
    HLGSyn[GsynhiCounter].attr:=atr;
  end;
  inc(GsynhiCounter);
end;


{
--- finish global highlight note --------------------------------------

unused.
}

procedure finGlobHiNote(var hln:PGlobHiNote;l:longint);
begin
  if hln<> nil then begin
    hln^.fln:= l;
  end;
end;

{
--- delete @spec.line of global highlight note ------------------------

unused.
}

procedure delLnGlobHiNote(var hln:PGlobHiNote;l:longint);
var
  tmp,tmpPre: PGlobHiNote;
begin
  if hln<>nil then begin
    tmp:= hln;
    tmpPre:= nil;
    while tmp<>nil do begin
      if tmp^.sln=l then begin
        if tmpPre<>nil then tmpPre^.next:=tmp^.next  { contact } else
           hln:= tmp^.next; { move base }
        dispose(tmp);
      end;
      tmpPre:=tmp;
    end;
  end;
end;

{
--- destroy global highlight notes -----------------------------------

unused.
}


procedure freeGlobHiNote(var hln:PGlobHiNote);
var
  tmp:PGlobHiNote;
begin
  while hln<>nil do begin
    tmp:=hln;
    hln:=hln^.next;
    dispose(tmp);
  end;
end;

{
--- local&global synhi tool -----------------------------------------

synhi - syntax highlight
}

procedure checkBHLSym(var s:string;i:word;HL:PGBHL);
var
  n,k,eq:byte;
begin

  for n:=0 to maxHLSyn do begin

      k:=0;
      eq:=1;

      { line highlight - lowest priority }

      { off }
      if (HL^.sta=_hlON) and (length(HLSyn[n].f)>0) then begin
        while k<length(HLSyn[n].f) do begin
          if s[i+k] <> HLSyn[n].f[k+1] then eq:=0;
          inc(k);
        end;
        if (eq=1) and (HL^.n=n) then begin
          HL^.sta:= _hlFINISH;
        end;
      end else

      { on }
      if (HL^.sta=_hlOFF) and (length(HLSyn[n].com)>0) then begin
        while k<length(HLSyn[n].com) do begin
          if s[i+k] <> HLSyn[n].com[k+1] then eq:=0;
          inc(k);
        end;
        if (eq=1) then begin
          HL^.n:=n; { left -> right highlight way }
          HL^.sta:= _hlON;
        end;
      end;

      { global highlight, but only line support }
      if (HL^.sta<>_ghLEAD) and (HL^.sta<>_hlON) then begin
        k:=0;
        eq:=1;
        while k<length(HLGSyn[n].s) do begin
          if s[i+k] <> HLGSyn[n].s[k+1] then eq:=0;
          inc(k);
        end;
        if (eq=1) and (length(HLGSyn[n].s)>0) then begin
          HL^.n:=n;
          HL^.sta:=_ghLEAD; { globSynhi leading character }
        end;
      end;

      k:=0;
      eq:=1;
      if (HL^.sta=_ghLEAD) and (length(HLGSyn[n].f)>0) then begin
        while k<length(HLGSyn[n].f) do begin
          if s[i+k] <> HLGSyn[n].f[k+1] then eq:=0;
          inc(k);
        end;
        if (eq=1) then begin
          if HL^.n= n then
          HL^.sta:= _ghFINISH; { globSynhi terminating character }
        end;
      end;
  end;
end;

{
--- global synhi tool ---------------------------------------------

synhi - syntax highlight
}

procedure checkGlobHi(var s:string;HL:PGBHL);
var
  n,leadHi:byte;
begin
  leadHi:=0;
  for n:=0 to maxHLSyn do begin
      { global highlight }
      if length(HLGSyn[n].s)>0 then
      if (HL^.sta<>_ghLEAD) then begin
        leadHi:=pos(HLGSyn[n].s,s);
        if (leadHi>0) then begin
          HL^.n:=n;
          HL^.sta:=_ghLEAD; { leading synhi character }
        end;
      end;

      if (length(HLGSyn[n].f)>0) then
        if (HL^.sta=_ghLEAD) then begin
        if (pos(HLGSyn[n].f,s)>leadHi) then begin
          if HL^.n= n then
            HL^.sta:= _ghFINISH; { terminating synhi character }
        end;
      end;

  end;
end;


{
--- line word color analysis&write --------------------------------
}

procedure WCwrite(var s:string;HL:PGBHL);
var
  preds,kwrd:string;
  attr:word;
  i: word;
begin
  while s<>'' do begin
    i:=1;
    { skip blank }
    textAttr:=defaultWCdraw;
    while (s[i] in blankChar) and (i<=length(s)) do inc(i);
    preds:= copy(s,1,i-1);
    write(preds);
    { search for first char of word }
    while (s[i] in notWordChar) and (i<=length(s)) do begin

      checkBHLSym(s,i,HL);
      case HL^.sta of
       _hlON: textAttr:= HLSyn[HL^.n].attr;
       _ghLEAD,_ghPASS: textAttr:= HLGSyn[HL^.n].attr;
       _ghFINISH: begin textAttr:=HLGSyn[HL^.n].attr; HL^.sta:=_hlOFF; end;
       _hlFINISH: begin
       textAttr:=HLSyn[HL^.n].attr; HL^.sta:=_hlOFF; end;
      end;

      write(s[i]);
      inc(i);
      if HL^.sta=_hlOFF then textAttr:=defaultWCdraw;
    end;
    { number highlight support }
    if HL^.sta=_hlOFF then
    if (s[i] in NumChar) and (i<=length(s)) then
     while (s[i] in exNumChar) and (i<=length(s)) do begin
      textAttr:= HLNum;
      write(s[i]);
      inc(i);
    end;


    { search for end char of word }
    j:=i; { save start }
    while (not (s[i] in notWordChar)) and (i<=length(s)) do inc(i);
    kwrd:= copy(s,j,i-j);
    delete(s,1,i-1);
    { fast first char search: }
    attr:=getParamWS(KeyWordSet[kwrd[1]],kwrd);
    textAttr:= defaultWCdraw;


    if attr<256 then
      textAttr:= attr
    else
      textAttr:= defaultWCdraw;

    case HL^.sta of
      _hlON:textAttr:= HLSyn[HL^.n].attr;
      _ghLEAD,_ghPASS: textAttr:= HLGSyn[HL^.n].attr;
    end;

    write(kwrd);

  end;
  if (HL^.sta=_hlON) then
    HL^.sta:= _hlOFF; { line highlight OFF if not global }
end;


{
--- load texedit's file -----------------------------------------------
}

procedure loadTexFile(var ds:TTexeditDescript);
begin
  loadStringsFile(ds.flName, ds.tex);
end;

{
--- load texedit's synhi ----------------------------------------------
}

procedure loadTexSynhi(var ds:TTexeditDescript);
var
  f:text;
  s:string;
  Path: PathStr;
  Dir: DirStr;
  Name: NameStr;
  Ext: ExtStr;
  fext: array[0..maxBuf] of extStr;
  next: integer;
  i:byte;

function SynhiExt(ft:string):boolean;
var
  i:byte;
begin
  SynhiExt:=false;
  for i:=0 to next-1 do
    if fext[i]=ext then begin
      SynhiExt:= true;
      exit;
    end;
  if (fext[0]='.*') then SynhiExt:=true;
end;

begin
{$I-}
  for i:=0 to maxBuf do fext[i]:='';
  path:= ds.flName;
  fsplit(path,dir,name,ext);

  assign(f,'plaintex.shi');
  reset(f);
  if IOResult<>0 then begin
    MB_ERRINF('Synhi file not found, setting defaults.');
  end
  else begin
    Cnln:=0;
    while not eof(f) do begin
      readln(f,s);
      inc(Cnln);
      cmd(s);
      case c of
        _synhiftype:begin
          if SynhiExt(ext) then break;
          for i:=0 to maxBuf do fext[i]:='';
          for i:=0 to xint[0]-1 do begin
            fext[i]:= xstr[i];
            next:=xint[0];
          end;
        end;

        _colors:begin
          texeditBgColor:= black;{byte(xint[1])};
          texeditTextColor:= lightGray;{byte(xint[0])};
        end;

        _addKeyword:begin
          if SynhiExt(ext) then begin
            addKeyword(xstr[0],byte(xint[0]));
          end;
        end;

        _addLsynhi:begin
          if SynhiExt(ext) then begin
            addLsynhi(xstr[0],xstr[1],byte(xint[0]));
          end;
        end;

        _addGsynhi:begin
          if SynhiExt(ext) then begin
            addGsynhi(xstr[0],xstr[1],xint[0]);
          end;
        end;
        _Nohi: HLNum:= byte(xint[0]);
      end;
    end;
    close(f);
  end;
  {$I+}
end;


{
--- texedit -----------------------------------------------------------

edituje datovou struturu typu TStrings

pri predavani MUSI byt tex jako kotva!

note: je to priserne napsany.

}

procedure texedit(var ds:TTexeditDescript;var tex:TStrings);
var
  xlen,ylen,lines,i: longint;
  eline,s,strToSearch: string;
  num, leftDist: string[6];
  kotva: pointer;
  lmark: TKey;
  HL: TGBHL;
  saveTex: TStrings;



procedure drawTex;                       { refresh text data on screen }
var
  s: string;
  i: word;
  j: byte;
  dataEnd,ghon: boolean;
  hln:byte;
  saveK:pointer;
begin

  ghon:= false;
  saveK:=tex;
  tex:= kotva;
  i:=1;
  curOff;
  { ...Yline TOP offset + synhi }
  while i <= ds.lineOfs-ds.curPos.y do begin

    s:= getCurLine(tex);
    checkGlobHi(s,@HL);

    if (HL.sta=_hlON) or (HL.sta=_ghFINISH) then HL.sta:= _hlOFF;
    goNextLine(tex);
    inc(i);
  end;

  edlineExit:=true;
  dataEnd:= false;
  for i:=1 to ylen do begin
    if not dataEnd then s:= getCurLine(tex);
    if texeditNumberLines then begin
      gotoxy(1,i);
      textColor(texeditLinesNumbersTextColor);  { draw line numbers }
      textBackground(texeditLinesNumbersBgColor);
      if not dataEnd then begin                 { end of textdata ? }
        str((i+ds.lineOfs-ds.curPos.y):5,num);
        if lineMarked(ds.lineOfs-ds.curPos.y+i-1,lmark) then begin { markers..}
          write(num);
          textColor(texeditMarkerTextColor);    { draw markers }
          textBackground(texeditMarkerBgColor);
          write(char(lmark));
        end
        else
          write(num+' ');
        textBackground(texeditBgColor);
        write(leftDist);
        edline(texeditLeftDist+7,i,xlen-6-texeditLeftDist,s,@HL);
      end
      else begin                                { YES, textdata end }
        write('      ');
        textBackground(texeditBgColor);
        write(leftDist);
        edline(texeditLeftDist+7,i,xlen-6-texeditLeftDist,s,@HL);
      end;
    end
    else begin
      gotoxy(1,i);
      textBackground(texeditBgColor);
      write(leftDist);
      edline(texeditLeftDist+1,i,xlen-texeditLeftDist,s,@HL);
    end;

    if tex^.next = kotva then begin
      dataEnd:= true; { write blank lines }
      s:='';
    end;
    goNextLine(tex);
  end;
  edlineExit:=false;
  tex:=saveK;
  curOn;
end;

begin
  HL.sta:= _hlOFF;
  strToSearch:= '';
  tex:= ds.tex;
  if tex=nil then addLine(tex,'');
  kotva:= tex;
  lines:= getNLines(tex);
  { left blank space }
  leftDist:= '';
  i:=1;
  while i<texeditLeftDist do begin leftDist:= leftDist + ' '; inc(i);end;

  edlineBlankDELETEleave:= true;  { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACEleave:= true; { leave if CurPtr=0 + Backspace pressed }
  edlineEditable:= ds.Editable;
  edlineEveryModify:= true;
  edlineBgColor:= texeditBgColor;
  edlineTextColor:= texeditTextColor;
  edlineEditOver:=texeditEditOver;
  edlineHighlight:=true;
  defaultWCdraw:= edlineTextColor;
  with ds do begin
    with win do begin         { width & height of edit win }
      window(x1,y1,x2,y2);
      textbackground(texeditTitleBgColor);
      clrscr;
      xlen:= abs(x2-x1)-1;
      ylen:= abs(y2-y1)+1;
      if ds.Title<>'' then begin { one line for title }
        gotoxy((abs(x2-x1) div 2)-(length(ds.Title+ds.flName) div 2),y1);
        textColor(texeditTitleTextColor);
        write(ds.Title+': '+ds.flName);
        window(x1,y1+1,x2,y2);
        dec(ylen);
      end;
      textbackground(texeditBgColor);
      clrscr;
    end;
    edlineCurPtr:= curPos.x;     { X - cursor position }
  end;
  goForLines(tex,ds.lineOfs);


  drawTex;
  if not texeditExit then
  repeat

    eline:=getCurLine(tex);
    if texeditLineHighlight then begin
      edlineBgColor:= texeditLineBgColor;
      edlineTextColor:= texeditLineTextColor;
    end;

    with ds do begin
      if texeditNumberLines then begin
        gotoxy(1,curPos.y+1);
        textColor(texeditLinesNumbersTextColor);
        TextBackground(texeditLinesNumbersBgColor);
        str((ds.lineOfs+1):5,num);

        if lineMarked(ds.lineOfs,lmark) then begin { markers..}
          write(num);
          textColor(texeditMarkerTextColor);    { draw markers }
          textBackground(texeditMarkerBgColor);
          write(char(lmark));
        end
        else
          write(num+' ');

        edline(texeditLeftDist+7,curPos.y+1,xlen-6-texeditLeftDist,eline,@HL);
      end
      else
        edline(texeditLeftDist+1,curPos.y+1,xlen-texeditLeftDist,eline,@HL);
      modifyLine(tex,eline);
      curPos.x:=edlineCurPtr;
    end;
    edlineBgColor:= texeditBgColor;
    edlineTextColor:= texeditTextColor;

    { word wrap event ? }
    if edlineWWrapEvent then begin
      edlineWWrapEvent:=false;
      goNextLine(tex);
      insertLine(tex,edlineWWrapFracStr);
      if ds.curPos.y<(ylen-1) then inc(ds.curPos.y);
      inc(ds.lineOfs);
      inc(lines);
      edlineCurPtr:=length(edlineWWrapFracStr);
      drawTex;
    end;

    case key of
      _arUp_:   begin                 { arrow up }

        if (ds.curPos.y>0) then begin
          dec(ds.curPos.y);
          dec(ds.lineOfs);
          goPredLine(tex);
        end
        else begin
          if ds.lineOfs>0 then begin  { scroll up screen }
            dec(ds.lineOfs);
            goPredLine(tex);
            {scrollScreenDown;}
          end;
        end;

        if texeditLineHighlight then drawTex;
        HL.sta:=_hlOFF;
      end;

      _arDown_: begin                 { arrow down }
        if (ds.curPos.y<(ylen-1)) and (ds.lineOfs<(lines-1)) then begin
          inc(ds.curPos.y);
          inc(ds.lineOfs);
          goNextLine(tex);
        end
        else begin
          if ds.lineOfs<(lines-1) then begin
            inc(ds.lineOfs);
            goNextLine(tex);
            {scrollScreenUp;}
          end;
        end;
        if texeditLineHighlight then drawTex;
        HL.sta:=_hlOFF;
      end;

      _Enter_: begin                  { enter - insert line }
        if ds.Editable then begin
          eline:= getCurLine(tex);
          modifyLine(tex,copy(eline,1,edlineCurPtr));
          eline:= copy(eline,edlineCurPtr+1,length(eline)-edlineCurPtr);
          goNextLine(tex);
          insertLine(tex,eline);
          if ds.curPos.y<(ylen-1) then inc(ds.curPos.y);
          inc(ds.lineOfs);
          inc(lines);
          edlineCurPtr:=0;
          drawTex;
        end;
      end;

      _Delete_:begin                  { delete line if current ='' }
        if  ds.Editable then begin
         if ((ds.lineOfs+1)<lines) then begin
          goNextLine(tex);
          eline:=getCurLine(tex); { store next line }
          deleteLine(tex);        { delete line below CursorY (next line) }
          goPredLine(tex);
          eline:= getCurLine(tex) + eline;
          modifyLine(tex,eline);  { contact line n+0 + n+1 }
          dec(lines);
          drawTex;
         end;
        end;
      end;

      _Alt_D_:begin               { delete current line }
          if tex^.next<>kotva then begin
            if tex=kotva then
              kotva:= tex^.next;
            deleteLine(tex);
            dec(lines);
            drawTex;
          end;
       end;

      _BackSpace_:begin           { delete preceeding line if first col. }
        if ds.Editable then begin
         if ds.lineOfs>0 then begin
          eline:= getCurLine(tex);
          deleteLine(tex);                 { delete line at CursorY }
          goPredLine(tex);
          i:= length(getCurLine(tex));     { save Xcur pos }
          eline:= getCurLine(tex) + eline; { contact line n+0 + n-1 }
          modifyLine(tex, eline);
          dec(ds.lineOfs);
          dec(ds.curPos.y);
          dec(lines);
          edlineCurPtr:= i;
          drawTex;
         end;
        end;
      end;

      _Ctrl_N_: begin                      { lines niumbers ON/OFF }
        texeditNumberLines:= not texeditNumberLines; { toggle number }
                                                     { bar }
        drawTex;
      end;

      _PgUp_: begin                        { scroll: page up }
        if ds.lineOfs>0 then begin
          if integer(ds.lineOfs)-integer(ylen)>=integer(ylen) then begin { $$$ arithmetic over!}
            ds.lineOfs:= ds.lineOfs - (ylen-1);
            goBackLines(tex,ylen-1);
          end
          else begin
            goBackLines(tex,ds.lineOfs);
            ds.lineOfs:= 0;
            ds.curPos.y:= 0;
          end;
        end;
        drawTex;
      end;

      _PgDown_: begin                      { scroll: page down }
        if ds.lineOfs<(lines-1) then begin
          if integer(lines)-integer(ds.lineOfs+ylen)>integer(ylen) then begin
            ds.lineOfs:= ds.lineOfs + (ylen-1);
            goForLines(tex,ylen-1);
          end
          else begin
            goForLines(tex,lines-ds.lineOfs-1);
            ds.lineOfs:= lines-1;
            if lines<ylen then
              ds.curPos.y:= lines-1
            else
              ds.curPos.y:= ylen-1;
          end;
        end;
        drawTex;
      end;

      _Ctrl_Q_: begin                      { go to bookmark }
        i:= ds.lineOfs; { save current position }
        lmark:= getKey; { 0..9 }
        if lmark in [_0_.._9_] then begin
          if texeditMarkers[lmark]<$FFFF then  { empty marker ? }
            ds.lineOfs:= texeditMarkers[lmark]; { goto MARKER }
          if ds.lineOfs < ylen then
            ds.curPos.y:= ds.lineOfs;
          if i<ds.lineOfs then
            goForLines(tex,ds.lineOfs-i);
          if i >ds.lineOfs then
            goBackLines(tex,i-ds.lineOfs);
        end;
        if (lmark=_F_) or (lmark=_f_) then begin
          s:= 'Enter string to search:';
          edlineExit:=true;
          edline(2,1,40,s,@HL);
          strToSearch:='';
          edlineExit:=false;
          edline(2,2,40,strToSearch,@HL);
          stringsWordSearch(tex,kotva,strToSearch,ds.lineOfs);
        end;

        drawTex;
      end;

      _Ctrl_L_:begin

        if tex^.next=kotva then begin
          MB_ERRINF('End of file');
          readln;
          {ds.lineOfs:=0;
          ds.curPos.y:=0;}
        end else begin
          stringsWordSearch(tex,kotva,strToSearch,ds.lineOfs);
          drawTex;
        end;
      end;

      _Ctrl_K_: begin                      { place bookmark }
        lmark:= getKey; { 0..9 }
        if lmark in [_0_.._9_] then
          texeditMarkers[lmark]:= ds.lineOfs; { current line }
      end;

      _Ctrl_PgUp_: begin                   { goto top of current page  }
        goBackLines(tex, ds.curPos.y);
        ds.lineOfs:= ds.lineOfs - ds.curPos.y;
        ds.curPos.y:= 0;
        drawTex;
      end;
                                           { goto bottom of current page  }
      _Ctrl_PgDown_: begin
        if lines>=ylen  then begin
          goForLines(tex,(ylen-1) - ds.CurPos.y);
          ds.lineOfs:= ds.lineOfs + (ylen-1) - ds.CurPos.y;
          ds.curPos.y:= ylen-1;
        end
        else begin
          goForLines(tex,(lines-1) - ds.CurPos.y);
          ds.lineOfs:= ds.lineOfs + ((lines-1) - ds.CurPos.y);
          ds.curPos.y:= lines-1;
        end;
        drawTex;
      end;

      _Ctrl_Home_: begin               { goto begin of texdata }
        goBackLines(tex,ds.lineOfs);
        ds.lineOfs:= 0;
        ds.curPos.y:= 0;
        drawTex;
      end;

      _Ctrl_End_: begin                { goto end of texdata }
        i:= ds.lineOfs;
        if lines>ylen  then begin
          ds.lineOfs:= lines- 1;
          ds.curPos.y:= ylen- 1;
        end
        else begin
          ds.curPos.y:= lines- 1;
          ds.lineOfs:= ds.curPos.y;
        end;

        if i<ds.lineOfs then
          goForLines(tex,ds.lineOfs-i);
        drawTex;
      end;

      _F2_:begin                       { save }
        saveTex:= kotva;
        saveTexFile(ds.flName,saveTex);
      end;
    end;
    ds.curPos.x:= edlineCurPtr;
    HL.sta:=_hlOFF;
  until (key= _Esc_) or sysReq;
  ds.tex:= kotva;
end;



{
---- HEX editor ------------------------------------------------------


do pole d se pristupuje linearne : array [0..n] a ne XY, nasledna
uprava na XY bude provadet out rutina.

+dodelat kopirovani a TABULATORY v edlajnu!

}

procedure hexedit(var ds:THexeditDescript;var d: array of THexeditData;
                  var attrib: array of THexeditDataAttrib);
label EDITHVAL;
var
  ylen : word;
  xlen,L : byte;          { L: # chars / "byte" F, FF, FFF... }
  dlen: word;             { data length }
  adrLen: byte;            { # chars. / address F,FF,FFF,FFFF }
  colDist: byte;          { FF <-> FF distance }
  i: byte;
  key: TKey;
  hexs: string;
  inputErr: byte;
  newVal: word;
  attribMask,attribCode: byte;
  BHLnull:PGBHL;
{
-- print top columns' nubers
}

procedure printColumns;
var
  i: byte;
begin
  for i:=0 to ds.columns-1 do begin
    gotoxy(adrLen+1+ds.leftOfs+(i*colDist)+ds.LabelLen,1);
    write(intToHex(i,2));
  end;
end;

{
-- most significant attribute color setting ? ---
}
function setMSAttribColor(attrib:byte):boolean;
var
  i:byte;
begin
  if ds.Attrib then begin
  for i:= 7 downto 0 do
    if ((attrib shr i) and $01) = 1 then begin
      edlineTextColor:=hexeditAttribTextColor[i];
      edlineBgColor:=hexeditAttribBgColor[i];
      textColor(hexeditAttribTextColor[i]);
      textBackground(hexeditAttribBgColor[i]);
      break;
    end
    else begin
      edlineTextColor:=hexeditTextColor;
      edlineBgColor:=hexeditBgColor;
      textColor(hexeditTextColor);
      textBackground(hexeditBgColor);
    end;
  end;
end;



{
-- draw HEX ---
}
procedure drawHex(index,n:word);
var
  x,y,i: byte;

  svalue,s: string;

begin
  edlineExit:=true;
  BHLnull^.n:=$FF;
  BHLnull^.sta:= _hlOFF;
  for y:=index to index+n-1 do begin
    if (y*ds.columns)+x >= dlen then break;
    gotoxy(1,y+1);
    textBackground(hexeditAddressBgColor);
    textColor(hexeditAddressTextColor);
    svalue:=intToHex(ds.addrOfs +(y* ds.columns),adrLen);
    write(' '+svalue);
    for x:=0 to ds.columns-1 do begin
     if ds.addrOfs+(y*ds.columns)+x >= dlen then break;
     { address label }
     if (@ds.GetAddrLabel <> nil) and (ds.LabelLen>0) then begin
       hexeditLabelAddr:= ds.addrOfs+(y*ds.columns)+x;
       ds.GetAddrLabel;
       svalue:= hexeditAddrLabel;
       if (integer(length(svalue))-integer(ds.LabelLen))>0 then  { truncate str. }
         delete(svalue, ds.LabelLen+1,length(svalue)-ds.LabelLen);
       if (integer(ds.LabelLen))-integer(length(svalue))>0 then
         repeat
           svalue:= svalue + ' ';
         until length(svalue)>=ds.LabelLen;
       textColor(hexeditLabelTextColor);
       textBackground(hexeditLabelBgColor);

       gotoxy((x*colDist)+ds.leftOfs+adrLen+1,y+1);
       write(svalue);
     end;
     svalue:=intToHex(d[ds.addrOfs+(y*ds.columns)+x],L);

     setMSAttribColor(attrib[ds.addrOfs+(y*ds.columns)+x]);
     if ds.FullView then begin
       s:= intToBin(d[ds.addrOfs+(y*ds.columns)+x],L*4);
       svalue:=svalue +' '+s;
       if L=2 then begin
        svalue:=svalue +' '+ char(lo(d[ds.addrOfs+(y*ds.columns)+x]));
        edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L+(L*4)+3,svalue,BHLnull);
       end
       else begin
         svalue:=svalue +' '+ char(lo(d[ds.addrOfs+(y*ds.columns)+x]));
         svalue:=svalue +' '+ char(hi(d[ds.addrOfs+(y*ds.columns)+x]));
         edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L+(L*4)+5,svalue,BHLnull);
       end;

     end else
       edline((x*colDist)+ds.leftOfs+adrLen+1+ds.LabelLen,y+1,L,svalue,BHLnull);


    end;
  end;
  edlineExit:=false;
end;

{
-- attrib key query --
}
function isAttribToggleKey(key:TKey;var attribMask,attribCode:byte):boolean;
begin
  i:=0;
  isAttribToggleKey:= false;
  if ds.Attrib then begin
    repeat
     inc(i);
    until (key=hexeditAttribKeys[i-1]) or (i>7);
    attribMask:= $01;
    if key=hexeditAttribKeys[i-1] then begin
      attribMask:= attribMask shl (i-1);
      isAttribToggleKey:= true;
      attribCode:= i-1;
    end;
  end;
end;


procedure EquAdrAttrib(Adr:word;attribMask:byte);
var
  i:byte;

function IsInEqu(p:byte): byte;
var i: byte;
begin
  IsInEqu:= 0;
  for i:=1 to MaxEqus do
    if ds.EquAdr[p,i]=Adr then IsInEqu:=1;
end;

begin
  for i:=1 to MaxEquAddr do begin
     if IsInEqu(i)=1 then begin
       for j:=1 to MaxEqus do
         if (ds.EquAdr[i,j]<$FFFF) and (Adr<>ds.EquAdr[i,j]) then
           attrib[ds.EquAdr[i,j]]:=attrib[ds.EquAdr[i,j]] xor attribMask;
     end;
  end;
end;


begin
  case ds.dataType of
    hexeditByte: begin
                   dlen:= sizeOf(d) div 2;;
                   L:= 2;
                 end;
    hexeditWord: begin
                   dlen:= sizeOf(d) div 2;
                   L:= 4;
                 end;
    hexedit12bit:begin
                   dlen:= sizeOf(d) div 2;
                   L:= 3;
                 end;
  end;

  adrLen:= 2;
  if dlen>$FF then adrLen:= 3;
  if dlen>$FFF then adrLen:= 4;

{  inc(ds.leftOfs);}
  edlineBlankDELETEleave:= false;
  edlineCurHomeBACKSPACEleave:= false;
  edlineEditable:= hexeditEditable;
  edlineEveryModify:= false;
  edlineBgColor:= hexeditBgColor;
  edlineTextColor:= hexeditTextColor;
  edlineLeaveLRkey:= false;

  with ds do begin
    with win do begin
      xlen:= abs(x2-x1)-1;
      ylen:= abs(y2-y1);
      if ds.columns>2 then
        {colDist:= (xlen-adrLen-1-ds.leftOfs-ds.LabelLen) div )ds.columns-1)}
        colDist:= (xlen-adrLen-1-ds.leftOfs-L-ds.LabelLen) div (ds.columns-1)
      else
        colDist:=0;
      i:= 0;
      if ds.Title<>'' then begin { one line for title }
        window(x1,y1,x2,y1);
        textBackground(hexeditTitleBgColor);
        clrscr;
        gotoxy((abs(x2-x1) div 2)-(length(ds.Title) div 2),y1);
        textColor(hexeditTitleTextColor);
        write(ds.Title);
        dec(ylen);
        inc(i);
      end;
      window(x1,y1+i,x2,y1+i);
      textBackground(hexeditAddressBgColor);
      textColor(hexeditAddressTextColor);
      clrscr;
      printColumns;
      window(x1,y1+1+i,x2,y2);
      textBackground(hexeditBgColor);
      clrscr;
    end;
    edlineCurPtr:= 0;
  end;
  drawHex(0,ylen);

  repeat
    gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
           ((ds.curAddr-ds.addrOfs) div ds.columns)+1);

    if (edlineLeaveLRkey) and (edlineLastKey<>_none_) then begin
      key:=edlineLastKey;
      edlineLastkey:=_none_;
    end
     else
       repeat key:=inkey; until ((key<>0) or sysReq);

    case key of
      _arUp_: begin
        if (ds.curAddr - ds.addrOfs)>=ds.columns then begin
          ds.curAddr:= ds.curAddr - ds.columns;
        end
        else
          if ds.addrOfs>(ds.columns-1) then begin
            ds.addrOfs:=ds.addrOfs- ds.columns;
            ds.curAddr:=ds.curAddr- ds.columns;
            scrollScreenDown;
            drawHex(0,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _arDown_: begin
        if ds.curAddr < (dlen - ds.columns) then
        if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
          ds.curAddr:= ds.curAddr + ds.columns;
        end
        else
          if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
       end;

      _PgDown_: begin
       for i:=1 to ylen do
       begin
        if ds.curAddr < (dlen - ds.columns) then
        if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
          ds.curAddr:= ds.curAddr + ds.columns;
        end
        else
          if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
       end;
       end;
      _PgUp_:begin
       for i:=1 to ylen do
       begin
        if (ds.curAddr - ds.addrOfs)>=ds.columns then begin
          ds.curAddr:= ds.curAddr - ds.columns;
        end
        else
          if ds.addrOfs>(ds.columns-1) then begin
            ds.addrOfs:=ds.addrOfs- ds.columns;
            ds.curAddr:=ds.curAddr- ds.columns;
            scrollScreenDown;
            drawHex(0,1);
          end;
        if edlineLeaveLRkey then goto EDITHVAL;
      end;
      end;

      _arLeft_:begin
        if (ds.curAddr mod ds.columns)>0 then
          dec(ds.curAddr);
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _arRight_:begin
        if (ds.curAddr mod ds.columns)<(ds.columns-1) then
          inc(ds.curAddr);
        if edlineLeaveLRkey then goto EDITHVAL;
      end;

      _Ctrl_X_:begin edlineLeaveLRkey:= not edlineLeaveLRkey; end;

      _Enter_: begin
        EDITHVAL:
        hexs:= intToHex(d[ds.curAddr],L);
        edlineBgColor:=hexeditEditBgColor;
        edlineTextColor:=hexeditEdittextColor;
        edlineEditable:= hexeditEditable;
        edlineEditOver:= false;
        edlineCurPtr:=0;
        edline((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
               ((ds.curAddr-ds.addrOfs) div ds.columns)+1,
               L,hexs,BHLnull);
        newVal:=hexToInt(hexs,inputErr);
        edlineBgColor:=hexeditBgColor;
        edlineTextColor:=hexeditTextColor;
        if (inputErr=0) and (newVal<>d[ds.curAddr]) then
          d[ds.curAddr]:= newVal
        else begin
          textBackground(hexeditBgColor);
          textColor(hexeditTextColor);
          gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
                 ((ds.curAddr-ds.addrOfs) div ds.columns)+1);
          write(intToHex(d[ds.curAddr],L));
        end;
        if ds.fullView then drawHex(ds.curAddr-ds.addrOfs,1);
      end;

      else begin
        { data atributes screen service }
        if isAttribToggleKey(key,attribMask,attribCode) then begin { query&color setting }

          attrib[ds.curAddr]:=attrib[ds.curAddr] xor attribMask;
          EquAdrAttrib(ds.curAddr,attribMask); { dalsi adresy, ktere jsou identicke }

          if ds.curAddr < (dlen - ds.columns) then
          if (ds.curAddr - ds.addrOfs)<((ylen-1)*ds.columns) then begin
            gotoxy((ds.curAddr mod ds.columns)*colDist +ds.leftOfs+adrLen+1+ds.LabelLen,
                 ((ds.curAddr-ds.addrOfs) div ds.columns)+1);
            { TAG attribute }
            if ((attrib[ds.curAddr] shr attribCode) and $01 ) = 1 then begin
              textColor(hexeditAttribTextColor[attribCode]);
              textBackGround(hexeditAttribBgColor[attribCode]);
            end
            else { show another attributes - UNTAG attribute }
              setMSAttribColor(attrib[ds.curAddr]);{ none attrib }


            write(intToHex(d[ds.curAddr],L));

            ds.curAddr:= ds.curAddr + ds.columns;
          end
          else { scroll screen ... }
            if (dlen-ds.addrOfs)>(ds.columns*ylen) then begin
            ds.addrOfs:=ds.addrOfs+ ds.columns;
            ds.curAddr:=ds.curAddr+ ds.columns;
            scrollScreenUp;
            drawHex(ylen-1,1);
          end;
        end;
      end;
    end;
  until (key=_Esc_) or hexeditExit or sysReq;
  edlineLeaveLRkey:= false;
end;

(*
{
--- message box -------------------------------------------------------
}

procedure viewMsg(var m: TMessages; var ds: TMessagesDescript);
var
  texDS: TtexeditDescript;
begin
  with texDS do begin
    curPos.x:= 0;
    curPos.y:= 0;
    lineOfs:= ds.msgOfs;
    title:= ds.title;
    win:= ds.win;  { cpy window pos }
    editable:= ds.editable;

  end;
  texedit(texDS, m);
end;

{
--- change message box ------------------------------------------------
}
procedure switchMsgBox(var m: TMessages; var ds: TMessagesDescript);
begin
  msgCurMessages:= m;
  msgCurDescript:= @ds;
end;

{            ]
--- addMessage --------------------------------------------------------
}

procedure Msg(m: string);
var
  texDS: TtexeditDescript;
begin
  with texDS do begin
    curPos.x:= 0;
    curPos.y:= 0;
    lineOfs:= msgCurDescript^.msgOfs;

    title:= msgCurDescript^.title;
    win:= msgCurDescript^.win;  { cpy window pos }
    editable:= msgCurDescript^.editable;
  end;
  if msgCurMessages=nil then begin { initialize first message }
    texDS.lineOfs:= 0;
    msgCurDescript^.msgOfs:=0;
  end;
  addLine(msgCurMessages, m);
  if getNLines(msgCurMessages)>(abs(texDS.win.y2-texDS.win.y1)+1) then begin
    deleteLine(msgCurMessages);
  end;
  texeditTextColor:= msgTextColor;
  texeditBgColor:= msgBgColor;
  texeditExit:= true;
  texedit(texDS, msgCurMessages);
  texeditExit:= false;
end;
*)

procedure MB_ERRINF(m:string);
begin
  {window(1,1,60,3);}
  textBackGround(red);
  textColor(white);
  gotoxy(5,1);
  write(m);
  inKey;
end;

begin
{ edline presets }
  edlineBgColor:= black;
  edlineTextColor:= lightGray;
  edlineCurPtr:= 0;
  edlineEditOver:= false;    { > length of edline (l) }
  edlineBlankDELETEleave:= false; { leave if string='' and DELETE key pressed }
  edlineCurHomeBACKSPACELeave:= false; { leave if CurPtr=0 + Backspace pressed }
  edlineEveryModify:= false;
  edlineEditable:= true;
  edlineMarkedTextColor:= white;
  edlineMarkedBgColor:= darkGray;
  edlineMarkColumn:= false;
  edlineInsert:= true;
  edlineTabbLength:= 8;
  edlineHighlight:=false;
  edlineWWrapEvent:= false;
  edlineWordWrap:=true;
  edlineWWrapFracStr:='';

{ texedit presets }
  texeditLeftDist:= 0;
  texeditBgColor:= black;
  texeditTextColor:= lightGray;
  texeditLinesNumbersTextColor:= darkGray;
  texeditLinesNumbersBgColor:= lightGray;
  texeditLineTextColor:= white;
  texeditLineBgColor:= black;
  texeditNumberLines:= false;
  texeditMarkerTextColor:= lightRed;
  texeditMarkerBgColor:= black;
  texeditTitleTextColor:= red;
  texeditTitleBgColor:= cyan;
  texeditLineHighlight:= true;
  texeditEditOver:= true;
  GsynhiCounter:=0;
  LsynhiCounter:=0;

  eraseMarkers(texeditMarkers);

{ hexedit presets }
  hexeditBgColor:= blue;
  hexeditTextColor:= yellow;
  hexeditEditBgColor:= cyan;
  hexeditEdittextColor:= black;
  hexeditTitleTextColor:= red;
  hexeditTitleBgColor:= cyan;
  hexeditAddressTextColor:=black;
  hexeditAddressBgColor:= lightGray;
  hexeditEditable:= true;
  hexeditExit:= false;
  hexeditAddrLabel:='';
  hexeditLabelAddr:=0; { address to get label.. }
  hexeditLabelTextColor:= white;
  hexeditLabelBgColor:= hexeditBgColor;

(*
{ msg }
  msgTextColor:= lightGreen;
  msgBgColor:= black;
*)
  for i:=0 to 7 do hexeditAttribKeys[i]:=_null_;
  for i:=0 to 7 do hexeditAttribTextColor[i]:= lightGreen;
  for i:=0 to 7 do hexeditAttribBgColor[i]:=blue;


{ CRT3 presets }
  sysReq:= false;
end.