{ univerzalna :) command line }
unit inifile;

interface

type
  TshortStr=string[20];
  Tcmd=(_none,_ftypeInfo, _synhiftype,_addLsynhi,_addGsynhi,_colors,
        _addKeyword,_Nohi);


const
  maxBuf=10;

var
  xreal: array[0..maxBuf] of real;
  xint:  array[0..maxBuf] of longint;
  xstr:  array[0..maxBuf] of TshortStr;
  cmdCont: array[0..maxBuf] of TshortStr;
  c, oldc:Tcmd;
  cmdStr: string;
  Cnln:integer;

procedure cmd(cs:string);
procedure odmazMezirky(var instr: string);
procedure cutIt;
function carveStr(s:string):string;

implementation

uses crt;


type
  Tpcmd=(none,OK);


var

  contInx: byte; {#paramstringu}
  pcmd: Tpcmd;
  err: byte;

procedure odmazMezirky(var instr: string);
begin
  while (instr[1]=#32) and (length(instr)>0) do {odmazani mezer....}
      delete(instr,1,1);
  delete(instr,pos(';;',instr),length(instr)-pos(';;',instr));

end;

procedure cutIt;
var
  i:byte;
begin
  cmdStr:= cmdStr + ' ';
  contInx:= 0;
  for i:=0 to 2 do
    cmdCont[i]:= '';
  while length(cmdStr)>0 do begin
    odmazMezirky(cmdStr);
    cmdCont[contInx]:=copy(cmdStr,1,pos(' ',cmdStr)-1);
    delete(cmdStr,1,pos(' ',cmdStr));
    inc(contInx);
  end;
end;

function cmdOK(nparam:byte):boolean;
var
  i:byte;
begin
  cmdOK:= true;
  for i:=0 to nparam-1 do
    if cmdCont[i]='' then begin
      cmdOK:= false;
      writeln('not enough parameters! see plaintex.shi');
      break;
    end;
end;

function carveStr(s:string):string;
begin
  if s='&blank' then carveStr:='' else
    if s='&comment' then
      carveStr:=';;' else
  carveStr:=s;
end;

function strToColor(s:string; var err:byte):byte;
begin
  err:=1;
  if s='black' then begin strToColor:=black; err:=0; end;
  if s='blue' then begin strToColor:=blue; err:=0; end;
  if s='green' then begin  strToColor:=green; err:=0; end;
  if s='cyan' then begin  strToColor:=cyan; err:=0; end;
  if s='red' then begin  strToColor:=red;   err:=0; end;
  if s='magenta' then begin  strToColor:=magenta; err:=0; end;
  if s='brown' then begin  strToColor:=brown; err:=0; end;
  if s='lightgray' then begin  strToColor:=lightGray; err:=0; end;
  if s='lightblue' then begin  strToColor:=lightblue; err:=0; end;
  if s='lightgreen' then begin  strToColor:=lightgreen; err:=0; end;
  if s='lightcyan' then begin  strToColor:=lightcyan; err:=0; end;
  if s='lightred' then begin  strToColor:=lightred; err:=0; end;
  if s='lightmagenta' then begin  strToColor:=lightmagenta; err:=0; end;
  if s='yellow' then begin  strToColor:=yellow; err:=0; end;
  if s='darkgray' then begin  strToColor:=darkGray; err:=0; end;
  if s='white' then begin  strToColor:=white; err:=0; end;
end;

function strToAttr(f,b:string;var err:byte):byte;
begin
  textColor(strToColor(f,err));
  if err<>0 then exit;
  textBackground(strToColor(b,err));
  strToAttr:=textAttr;
end;

procedure cmd(cs:string);
var
  i:byte;
begin
  {clear command buffers}
  for i:=0 to maxBuf do
    cmdCont[i]:='';

  cmdStr:= cs;
  cutIt;
  pcmd:=none;
  c:=_none;
  err:= 0;

  { colors, [foreground background] }
  if (cmdCont[0] = '#colors') then begin
    if cmdOK(3) then begin
      xint[0]:=strToColor(carveStr(cmdCont[1]),err);
      if err=0 then begin
        xint[1]:=strToColor(carveStr(cmdCont[2]),err);
        if err=0 then begin
          pcmd:=OK;
          c:= _Colors;
        end;
      end;
    end;
  end;

  if (cmdCont[0] = '#editable') then begin
    if cmdOK(2) then begin
      xstr[0]:=carveStr(cmdCont[1]);
      xint[0]:=strToColor(carveStr(cmdCont[2]),err);
          pcmd:=OK;
          c:= _Colors;

    end;
  end;

(*
  { fileType info, ["file extension"] }
  if (cmdCont[0] = '#ftype') then begin
    if cmdOK(1) then begin
      xstr[0]:=carveStr(cmdCont[1]);
      xint[0]:=1; {# filetypes}
      if (xstr[0]<>'') then begin
        i:=2;
        while (carveStr(cmdCont[i])<>'') and (i<=maxbuf) then begin
          xstr[i-1]:=carveStr(cmdCont[i]);
          inc(xint[0]);
        end;
        pcmd:=OK;
        c:= _FtypeInfo;
      end;
    end;
  end;*)

  { fileType, ["file extension"] }
  if (cmdCont[0] = '#synhiftype') then begin
    if cmdOK(2) then begin
      i:=1;
      while (carveStr(cmdCont[i])<>'') and (i<=maxbuf) do begin
        xstr[i-1]:=carveStr(cmdCont[i]);
        inc(i);
      end;
      xint[0]:=i;
      pcmd:=OK;
      c:= _synhiFtype;
    end;
  end;

  { add keyword highlight, ["keyword" "foreground" "background"] }
  if (cmdCont[0] = '#kwhi') then begin
    if cmdOK(3) then begin
      xstr[0]:=cmdCont[1];
      xint[0]:=strToAttr(carveStr(cmdCont[2]),carveStr(cmdCont[3]),err);
      if (err=0) then begin
        pcmd:=OK;
        c:= _addKeyword;
      end;
    end;
  end;

  if (cmdCont[0] = '#nohi') then begin
    if cmdOK(3) then begin
      xint[0]:=strToAttr(carveStr(cmdCont[1]),carveStr(cmdCont[2]),err);
      if (xstr[0]<>'') then begin
        pcmd:=OK;
        c:= _Nohi;
      end;
    end;
  end;

  { local syntax highlight ["leading" "closing" "foreground" "background"] }
  if (cmdCont[0] = '#lsynhi') then begin
    if cmdOK(4) then begin
      xstr[0]:=carveStr(cmdCont[1]);
      xstr[1]:=carveStr(cmdCont[2]);
      xint[0]:=strToAttr(carveStr(cmdCont[3]),carveStr(cmdCont[4]),err);
      if (xstr[0]<>'') then begin
        pcmd:=OK;
        c:= _addLsynhi;
      end;
    end;
  end;


  { global syntax highlight ["leading" "closing" "foreground" "background"] }
  if (cmdCont[0] = '#gsynhi') then begin
    if cmdOK(4) then begin
      xstr[0]:=carveStr(cmdCont[1]);
      xstr[1]:=carveStr(cmdCont[2]);
      xint[0]:=strToAttr(carveStr(cmdCont[3]),carveStr(cmdCont[4]),err);
      if (xstr[0]<>'') and (xstr[1]<>'') then begin
        pcmd:=OK;
        c:= _addGsynhi;
      end;
   end;
  end;


  if (pcmd=none) and (length(cmdCont[0])>0) then begin
    writeln('unknown parameter or error at:',err,' see plaintex.shi :',Cnln);
    readln;
  end;
  oldc:= c;
end;

end.